
/*
 * Comme je ne connaissais pas la frequence du port en E/S
 * j'ai fait ce petit programme qui permet de la determiner
 * experimentalement j'ai fixer la dure de la boucle sur
 * 10 Millions pour avoir une mesure plus facile
 * comme la frequence du port est faible les temps pris par
 * les autres instructions dans la boucle est recouvert par
 * le "in". Il n'apparrait donc pas le temp mesurer (ce qui
 * permet d'ailleur de faire une mesure juste)
 * Donc le frequence vaut donc:
 * f (Hz) = nb_de_valeur_de_la_boucle/temp_en_seconde
 * (rappel: f=1/t)
 * si le nb de valeur est en Millions la frequence est alors
 * en Mhz.
 * sur mon 486dx2-66 cela donne 1Mhz
 *
 * Compilateur utilise: Watcom 16 ou 32 bits
 *
 * Patrick Bricout
 */

#include <stdio.h>
#include <conio.h>

/* -------------------------------------------------
 * Peut etre compile indifferement en 16 ou 32 bits
 */

void testPort(void);
#pragma aux testPort=\
	"cli"\
	"mov dx,201h"\
	"mov bx,10000"\
"loop1:"\
	"mov cx,1000"\
"loop2:"\
	"in	al,dx"\
	"dec cx"\
	"jnz loop2"\
	"dec bx"\
	"jnz loop1"\
	"sti" modify[ax bx cx dx];


void main(void)
{
	printf("Ce programme permet de tester la vitesse du port E/S joystick (I/O:0x201)\n"
		   "il vous suffit de mesurer le nb de secondes du test\n"
		   "la frequence en Mhz vaut alors 10 divis par le temps_pris\n"
		   "exemple:9 ou 13 secondes => 1 Mhz\n"
		   "Rmq:arrondir au plus proche"
		   );
	printf("Taper une touche pour lancer le test....\n");
	getch();
	testPort();
	printf("Fini...\n");
}
